<template>
  <div style="margin-top:70px" class="content-grid content-grid--subpage content-grid--subpage-table">
   
    <div class="content-grid__header">
      <h1 class="back-link-title">{{ t(`routes.admin.children.membres.name`) }}</h1>
      <div class="content-grid__filters">
        <SearchInput v-model="searchValue"/>
      </div>
    </div>
    <Card>
      <DataTable
        :headers="memberHeader"
        :items="tableMember"
        :search-value="searchValue"
        @delete="deleteMembre" />
      
    </Card>
  </div>
</template>
<script lang="ts" setup>
import { useI18n } from "vue3-i18n";
import { computed, onMounted, ref } from "vue";
import {useMemberService} from "@/inversify.config";
import { notifyError, notifySuccess } from "@/notify";
import Card from "@/components/layout/Card.vue";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import DataTable from "@/components/layout/DataTable.vue";
import SearchInput from "@/components/layout/SearchInput.vue";
import {Guid, Member} from "@/types";

const { t } = useI18n();
const allMembers = ref<Member[]>([]);
const memberService = useMemberService();
const searchValue = ref("");

const tableMember = computed(() => {
  return allMembers.value
    .map((x: Member) => {
      if (x.roles == null || x.roles.length === 0) 
        x.roles = ["Aucun"];
      else if (x.roles[0] == "admin")
        x.roles[0] = "Administrateur";
      else if (x.roles[0] == "member")
        x.roles[0] = "Utilisateur";
      return {
        id: x.id,
        firstName: x.firstName,
        lastName: x.lastName,
        role: x.roles[0],
        actions: {
          update: {
            path: `/fr/cours/${x.id}/modifier`,
            params: { id: x.id },
          },
          delete: true,
          view: {
            path: `/fr/cours/${x.id}/details`,
            params: {
              id: x.id,
            },
          },
        },
      };
    })
    .sort((a: any, b: any) => {
      if (a.name < b.name) {
        return -1;
      }
      if (a.name > b.name) {
        return 1;
      }
      return 0;
    }) as unknown as Member[];
});
onMounted(async () => {
  await loadAllMembers();
});

async function loadAllMembers() {
  let members = await memberService.getAllMembers();
  if (members && members.length > 0) allMembers.value = members;
  console.log(members);
}

async function deleteMembre(member: Member) {
  if (member.id == null) return;
  let confirmation = confirm(t("validation.member.delete.confirmation"));
  if (!confirmation) return;
  console.log(member.id);

  let response = await memberService.deleteMember(member.id);
  console.log(response)
  if (response.errors.length === 0) {
    allMembers.value = allMembers.value.filter((x) => x.id !== member.id);
    notifySuccess(t("validation.member.delete.success"));
  } else {
    let errorMessages = response.getErrorMessages(
      "validation.member.delete",
      "validation.member.delete.errorOccured"
    );
    notifyError(errorMessages[0]);
  }
}

const memberHeader = [
  {
    text: "Prénom",
    value: "firstName",
    sortable: true,
    width: 150,
  },
  {
    text: "Nom",
    value: "lastName",
    sortable: true,
    width: 150,
  },
  {
    text: "Rôle",
    value: "role",
    sortable: true,
    width: 75,
  },
  {
    text: "",
    value: "actions",
    width: 75,
  },
];
</script>
